//importing necessary libraries from d3 and topojson

import { select, json, geoPath, geoNaturalEarth1 } from 'd3';
import { feature } from 'topojson';

const svg = select('svg');
//Projection transform spherical polygonal geometry to planar polygonal geometry
const projection = geoNaturalEarth1();
//PathGenerator is used for to transform an SVG path data string.
const pathGenerator = geoPath().projection(projection);

svg.append('path')
    .attr('class', 'sphere')
//Sphere type is used to render the outline of the globe
    .attr('d', pathGenerator({type: 'Sphere'}));
//importing the world map data into json format
json('https://unpkg.com/world-atlas@2.0.2/countries-50m.json')
  .then(data => {
    const countries = feature(data, data.objects.countries); //Extracting countries from topojson
    svg.selectAll('path').data(countries.features)
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator);
  });
